using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using System.Xml;
using System.Xml.Xsl;
using System.IO;

public partial class _Default : System.Web.UI.Page 
{
    protected void Page_Load(object sender, EventArgs e)
    {
        gdvData.DataSource = GetData();
        gdvData.DataBind();   
     
    }

    DataSet GetData()
    {
        SqlConnection con = new SqlConnection(@"Data Source=.\sqlexpress;Initial Catalog=Northwind;Integrated Security=True");
        SqlCommand com = new SqlCommand("SELECT [ProductID], [ProductName], [UnitPrice] FROM [products]", con);
        SqlDataAdapter ada = new SqlDataAdapter(com);
        DataSet ds = new DataSet();
        ada.Fill(ds);
        return ds;
    }
    protected void btnGenerate_Click(object sender, EventArgs e)
    {
        
        string procInfo = "type='text/xsl' href='" + "\\transform.xslt" + "'";//Processing info for XSLT
        string TempPath = Environment.GetFolderPath(Environment.SpecialFolder.InternetCache);
        string XMLPath=TempPath+ "\\Products.xml"; //temp path to store the XML file
        string XLSPath = TempPath + "\\Products.xls";//temp path to store the XLS file


        //Write the dataset as XML file with some XSLT processing information
        using (XmlTextWriter tw = new XmlTextWriter(XMLPath ,
                   null))
        {
            tw.Formatting = Formatting.Indented;
            tw.Indentation = 3;
            tw.WriteStartDocument();           
            DataSet ds = GetData();
            ds.Tables[0].TableName = "Products";
            tw.WriteProcessingInstruction("xml-stylesheet", procInfo);
            ds.WriteXml(tw);
        }         


        XmlDataDocument xmldoc = new XmlDataDocument();
        xmldoc.Load(XMLPath);
        XslCompiledTransform xsl = new XslCompiledTransform();
        xsl.Load(Server.MapPath(".")+"\\Transform.xslt");



        using (XmlTextWriter tw = new XmlTextWriter(XLSPath, System.Text.Encoding.UTF8))
        {
            tw.Formatting = Formatting.Indented;
            tw.Indentation = 3;
            tw.WriteStartDocument();
            xsl.Transform(xmldoc, null, tw);//Performa XSLT transformation.
        }



        //Streams the generated XLS file to the user
        byte[] Buffer = null;
        using (FileStream MyFileStream = new FileStream(XLSPath, FileMode.Open))
        {
            // Total bytes to read: 
            long size;
            size = MyFileStream.Length;
            Buffer = new byte[size];
            MyFileStream.Read(Buffer, 0, int.Parse(MyFileStream.Length.ToString()));
        }
        Response.ContentType = "application/xls";
        string header = "attachment; filename=" +"Products.xls";
        Response.AddHeader("content-disposition", header);
        Response.BinaryWrite(Buffer);
        Response.Flush();
        Response.End();

    }
}
